; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; SimpleSnake mit Fress-Sound
; ----------------------------------------------
; Immer noch ein kleines simples Snakespiel, aber mit Fress-Sound und ggf. besserer Auflsung
; modifiziert von Jrgen Cassing

AppTitle("Smacking SimpleSnake")

;Bildschirmauflsung
Const breit=1024;			n a t  r l i c h  
Const hoch = 768;					 n d e r b a r
Const du	= breit/32; Durchmesser 20 bei 640er Auflsung , 32 bei 1024er

;Tasten
Const rechts=205
Const links =203
Const oben  =200 
Const unten =208
Const enter = 28
Const pause = 25
Const F12	= 88
Const esc	=  1


; Damit das ganze nicht so schnell luft.
SeedRnd(MilliSecs())
Global zeit = MilliSecs()
Global takt		= 100; wird langsam hochgezhlt bis maxtakt
Const  maxtakt	= 200

; Die Sterne im Hintergrund
Dim sx(500)
Dim sy(500)
For i = 1 To 500
	sx(i) = Rnd(0,breit)
	sy(i) = Rnd(0,hoch)
Next

Global score	= 0
Global schnapp	= 0
Global anpause	= 0

; Die Lnge der Schlange
Const maxlaenge = breit/du * hoch/du  ; maximal 32*24=768 Schlangenteile.
Global laenge = 5
Dim snakex(maxlaenge + 1)
Dim snakey(maxlaenge + 1)


; Anfangsposition
Global x = 15
Global y = 12
For i = 0 To laenge
 snakex(i) = x - i
 snakey(i) = y
Next

; Die Schlange geht am Anfang nach rechts
Global xplus = 1
Global yplus = 0

; Position des Punktes den man einsammeln muss.
Global px = Rnd(1,breit/du-1)
Global py = Rnd(1,hoch/du-1)

; Vorberechnete Sinus/Cosinus-Tabellen
Dim   sinus#(360)
Dim cosinus#(360)

For i = 0 To 360
	  sinus#(i) = Sin(i)
	cosinus#(i) = Cos(i)
Next

Dim xx(999), yy#(999), vv#(999)

;Fonts und Fress-Sound 
Global kleinschrift
Global schrift
Global lecker


; d a s   H a u p t p r o g r a m m 


Graphics breit, hoch, 16, 1
SetBuffer BackBuffer()

;								   (fett, kursiv, unterstr)	
kleinschrift= LoadFont("arial", 18, False, False, False)
schrift		= LoadFont("arial", 72, True, False, False)
lecker		= LoadSound("fress.wav")



; die Hauptschleife

Repeat
	Cls
	anpause = 0
	TASTENPRUEFEN; incl. esc-->endemalen()
	SNAKEBEWEGEN ; incl. ggf-->endemalen()
	ALLESMALEN
	STATUS
	
 	If schnapp=1 Then SaveBuffer (BackBuffer(),"schnappschuss.bmp"):schnapp = 0	; F12

	While Not anpause=0 	
			Color 255,0,0:	Text breit/2-StringWidth("P = Ende der Pause")/2, hoch/2-FontHeight(), "P = Ende der Pause"
			If KeyHit (pause) Then FlushKeys: Exit
			Flip
	Wend

	Flip
Forever

End


; d i e   F u n k t i o n e n



;-----------------------------------------------------------------------
Function TASTENPRUEFEN(); Tastenabfrage

 If KeyHit(rechts) Then	If xplus = 0 Or xplus = 1 Then xplus = 1:yplus = 0
 If KeyHit(links ) Then	If xplus = 0 Or xplus =-1 Then xplus =-1:yplus = 0
 If KeyHit(unten ) Then	If yplus = 0 Or yplus = 1 Then xplus = 0:yplus = 1
 If KeyHit(oben  ) Then	If yplus = 0 Or yplus =-1 Then xplus = 0:yplus =-1
 If KeyDown(F12  ) Then FlushKeys:	schnapp = 1
 If KeyHit(pause ) Then anpause=1

 If KeyHit(esc   ) Then	ENDEMALEN

End Function




;----------------------------------------------------------------------
Function SNAKEBEWEGEN()

 If MilliSecs() - zeit >= takt Then

	zeit = MilliSecs()

	If takt < maxtakt Then takt = takt+1

	x = x + xplus ; xplus und yplus werden in TASTENPRUEFEN() gesetzt.
	y = y + yplus


	; Wenn er am Rand ist...
	If x > breit/du - 1 Or x < 0 Or y > hoch/du - 1 Or y < 0 Then ENDEMALEN

	; Jedem Punkt werden die Koordinaten des davorliegenden zugewiesen.
	; Das eigentlich wichtige an einem Snake-Programm.
	;____
	For i = laenge To 1 Step -1
		snakex(i) = snakex(i-1)
		snakey(i) = snakey(i-1)
	Next
	;---------

	; Der erste Punkt hat die Hauptkoordinaten. Die des Anfangs eben.
	snakex(0) = x
	snakey(0) = y


	; Den Kopf auf Kollision mit der Schlange berprfen. Wenn ja, Ende.
	For i = 1 To laenge
		If x = snakex(i) And y = snakey(i) Then ENDEMALEN
	Next


	KOLLISIONPRUEFEN

 EndIf
End Function





Function ALLESMALEN()
 
 ; Jeder Kreis der Schlange wird gemalt 
 For i = 0 To laenge
	Color 150-150*snakex(i)*du/breit,50-50*snakey(i)*du/hoch,150*snakex(i)*du/breit:	Oval snakex(i)*du, snakey(i)*du, du,du
	Color 150*snakey(i)*du/hoch,50-50*snakex(i)*du/breit,150-150*snakey(i)*du/hoch:	Oval snakex(i)*du, snakey(i)*du, du,du,0
 Next

 Color 255,  0,  0:	Oval x*du+du/4, y*du+du/4, du/2,du/2

 ; Den anderen Kreis malen.
 Color   0,  0,255: Oval px*du, py*du, du,du
 Color 100,100,255: Oval px*du, py*du, du,du,0



 ; Damit die Sterne mit WritePixelFast gemalt werden muss man zuerst den aktiven Buffer sperren.
 LockBuffer BackBuffer()
 ; Und die Sterne malen.
 sternwinkel = WINKEL(x*du, y*du, breit/2+1, hoch/2+1)

 For i = 1 To 500

	If i < 200 Then
		r = 100: g = 100: b = 100
		sx(i) = XBEWEGEN(sx(i), sternwinkel, 1)	
		sy(i) = YBEWEGEN(sy(i), sternwinkel, 1)
	EndIf

	If i < 350 And i > 199 Then
		r = 170: g = 170: b = 170
		sx(i) = XBEWEGEN(sx(i), sternwinkel, 2)
		sy(i) = YBEWEGEN(sy(i), sternwinkel, 2)
	EndIf

	If i > 349 Then
		r = 255: g = 255: b = 255
		sx(i) = XBEWEGEN(sx(i), sternwinkel, 3)
		sy(i) = YBEWEGEN(sy(i), sternwinkel, 3)
	EndIf

	If sx(i) < 0 		Then sx(i) = sx(i)+breit
	If sx(i) > breit	Then sx(i) = sx(i)-breit
	If sy(i) < 0 		Then sy(i) = sy(i)+hoch
	If sy(i) > hoch 	Then sy(i) = sy(i)-hoch


	; WritePixelFast ist u.a. deswegen schneller als Plot und WritePixel weil es nicht prft ob der Punkt noch auf dem Bildschirm liegt.
	; Dadurch kommt es aber auch zu abstrzen wenn man den Punkt auerhalb des Bildschirms zeichnet. Also --> Vorsicht...
	WritePixelFast sx(i), sy(i), RGB(r,g,b)
 Next

 UnlockBuffer BackBuffer() ; Und wieder entsperren

End Function




Function STATUS()
 SetFont kleinschrift
 Color 0,0,255: Text 10,20, "F12": Text 50,20, "=  Schnappschuss" 
 Color 0,0,255: Text 10,40, "P  ": Text 50,40, "=  Pause" 
 SetFont schrift
 Color 255,255,0: Text breit/2 - StringWidth(Str(score))/2 , 1, score
End Function






Function KOLLISIONPRUEFEN()
 ; Schlangenkopf auf Kollision mit Kreis berprfen
 If x = px And y = py Then
	PlaySound lecker
	laenge = laenge + 3 ; Schlange wird lnger
	For i = laenge -3 To laenge
		snakex(i) = snakex(i-1)
		snakey(i) = snakey(i-1)
	Next
	score = score + laenge ; Man bekommt mehr Punkte je lnger die Schlange ist.


	Repeat  
		mist=0
		px = Rnd(1,breit/du-4)
		py = Rnd(1,hoch /du-2)

		For i=1 To laenge  
			If snakex(i)= px And snakey(i)=py Then mist=mist+1	
		Next

	Until mist = 0

 EndIf

End Function







; Errechnet Winkel zwischen Kopf und Bildschirmmitte.
Function WINKEL(x1,y1,x2,y2)

 axx = x1-x2
 ayy = y1-y2

 ; Sqr = Wurzel
 abstand#	= Sqr (axx^2+ayy^2)
 wi			= ACos(axx / abstand#)

;If Sgn(axx) =  1 And Sgn(ayy) =  1 Then wi =    wi ;  0 + (180 - wi)		-1/-1	|	 1/-1
;If Sgn(axx) = -1 And Sgn(ayy) =  1 Then wi =    wi ; 90 + ( 90 - wi)		_________________
 If Sgn(axx) = -1 And Sgn(ayy) = -1 Then wi =360-wi ;180 + (180 - wi)
 If Sgn(axx) =  1 And Sgn(ayy) = -1 Then wi =360-wi ;270 + ( 90 - wi)		-1/1	|	 1/ 1

 wi=Abs(wi)
 Return wi
End Function



; Einen Punkt(Stern) in eine Richtung bewegen.
Function XBEWEGEN(aua,wi,affe)

 richtung = aua + Cosinus#(wi)*affe: Return richtung
End Function




; Das gleiche mit y#.
Function YBEWEGEN(aua,wi,affe)

 richtung = aua +   Sinus#(wi)*affe: Return richtung
End Function




; Aus RGB-Werten einen ReadPixelFast-Farbwert errechnen. 
Function RGB(rot,gruen,blau)

 Return blau   Or  gruen Shl 8   Or   rot Shl 16
End Function 







Function ENDEMALEN()

 ; Nochmal die ganzen Kreise malen.
 zeit = MilliSecs()
 Repeat
	Cls
	For x = 0 To breit/du:	For y = 0 To hoch/du
		Color 150-150*x*du/breit,50-50*y*du/hoch,150*x*du/breit:	Oval x*du, y*du, du,du
		Color 150*y*du/hoch,50-50*x*du/breit,150-150*y*du/hoch:		Oval x*du, y*du, du,du,0
	Next:					Next
	Color 255,0,0:	Text breit/2-StringWidth("Ende")/2, hoch/2-FontHeight(), "Ende"
	Flip
 Until MilliSecs() - zeit >= 2000  Or KeyHit(esc) Or KeyHit(enter); 2 Sekunden warten. (2000 Millisekunden)


	For i=0 To 999
		xx (i)=Rnd(1,breit-1)
		yy#(i)=Rnd(1,hoch-1)
		vv#(i)=Rnd(0.2,1)
	Next

 Repeat
	ClsColor Rnd(0,40),Rnd(0,40), Rnd(0,40)
	Cls
	Color Rnd(0,60),Rnd(0,60), Rnd(0,60)
	Text breit/2-StringWidth("Punkte: " + Str(score))/2, hoch/2-FontHeight()/2, "Punkte: " + score

	For i=0 To 999
		yy#(i)=yy#(i)+vv#(i)
		If yy#(i)>hoch-1 Then xx(i)=Rand(0,breit-1):yy#(i)=yy#(i)-hoch+1:vv#(i)=Rnd(0.2,1)
		affe=Int(vv#(i)*255)
;		Helligkeit = f(fallgeschwindigkeit). das erzeugt tiefe 
		Farbe=affe*$10000+affe*$100+affe
		WritePixel xx(i),yy#(i),Farbe
	Next

	Flip
 Until KeyHit(esc) Or KeyHit(enter)

 End
End Function