; Robs BB-Kurs 2
; Robert Gerlach 11.2001
;
; SimpleSnake
; ----------------------------------------------
; Ein kleines simples Snakespiel ohne externe Dateien, dafr
; mit Parallax-Sternenfeld, Regenbogen-Schlange und bunten Punkten am Ende ^_^




Graphics 640, 480, 16, 1
SetBuffer BackBuffer()


SeedRnd(MilliSecs())

; Anfansgposition des Spielers
Global x = 15
Global y = 12


; Position des Punktes den man einsammeln muss.
Global px = Rnd(1,30)
Global py = Rnd(1,10)



; Die Sterne im Hintergrund. Wre sonst etwas zu langweilig...
; Sie bewegen sich immer in Richtung des Schlangenkopfes.
Dim sx#(500)
Dim sy#(500)
For i = 1 To 500
sx#(i) = Rnd(0,640)
sy#(i) = Rnd(0,480)
Next



; Der Score
Global score = 0


; Die Schlange geht nach rechts
Global xplus = 1
Global yplus = 0


; Die Lnge der Schlange
Global maxlaenge = 768  ; Bei einer Gre von 20x20 passen maximal 768 Schlangenteile auf einen 640x480 Bildschirm.
Global laenge = 5
Dim snakex(maxlaenge + 1)
Dim snakey(maxlaenge + 1)
For i = 0 To laenge
snakex(i) = x - i
snakey(i) = y
Next

; Damit das ganze nicht so schnell luft.
Global zeit = MilliSecs()


; Vorberechnete Sinus/Cosinus-Tabellen
Dim sinus#(360)
Dim cosinus#(360)

For i = 0 To 360
sinus#(i) = Sin(i)
cosinus#(i) = Cos(i)
Next



; Hauptschleife
Repeat
Cls

tastenpruefen
snakebewegen
status

Flip
Forever
End





;-----------------------------------------------------------------------
Function tastenpruefen()
; Tastenabfrage

If KeyHit(205) Then ; rechts
If xplus = 0 Or xplus = 1 Then
xplus = 1
yplus = 0
EndIf
EndIf



If KeyHit(203) Then ; links
If xplus = 0 Or xplus = -1 Then
xplus = -1
yplus = 0
EndIf
EndIf



If KeyHit(208) Then ; unten
If yplus = 0 Or yplus = 1 Then
xplus = 0
yplus = 1
EndIf
EndIf



If KeyHit(200) Then ; oben
If yplus = 0 Or yplus = -1 Then
xplus = 0
yplus = -1
EndIf
EndIf


If KeyHit(1) Then ende


End Function




;----------------------------------------------------------------------
Function snakebewegen()

If MilliSecs() - zeit >= 200 Then
zeit = MilliSecs()

x = x + xplus ; xplus und yplus werden in tastenpruefen() gesetzt.
y = y + yplus


; Wenn er am Rand ist, kommt er an der anderen Seite wieder raus
If x > 31 Or x < 0 Or y > 23 Or y < 0 Then ende


; Jedem Punkt werden die Koordinaten des davorliegenden zugewiesen.
; Das eigentlich wichtige an einem Snake-Programm.
;_________
For i = laenge To 1 Step -1
snakex(i) = snakex(i - 1)
snakey(i) = snakey(i - 1)
Next
;---------

; Der erste Punkt hat die Hauptkoordinaten. Die des Anfangs eben.
snakex(0) = x
snakey(0) = y


; Den Kopf auf Kollision mit der Schlange berprfen. Wenn ja, Ende.
For i = 1 To laenge
If snakex(0) = snakex(i) And snakey(0) = snakey(i) Then ende
Next


kollisionpruefen



EndIf



; Jeder Punkt der Linie wird gemalt
For i = 0 To laenge
Color 153,(snakey(i)*20) / 2, (snakex(i)*15) / 2
Oval snakex(i)*20, snakey(i)*20, 20,20
Color (snakex(i)*15) / 2,(snakey(i)*20) / 2,153
Oval snakex(i)*20, snakey(i)*20, 20,20,0
Next


; Den anderen Punkt malen.
Color 0,0,255
Oval px*20, py*20, 20,20
Color 100,100,255
Oval px*20, py*20, 20,20,0



; Damit die Sterne schneller gemalt werden (mit WritePixelFast) muss man zuerst den aktiven
; Buffer sperren.
LockBuffer BackBuffer()
; Und die Sterne malen.
sternwinkel# = winkel#(x*20, y*20, 321, 241)
For i = 1 To 500

If sx#(i) < 1 Then sx#(i) = 639
If sx#(i) > 639 Then sx#(i) = 1
If sy#(i) < 1 Then sy#(i) = 479
If sy#(i) > 479 Then sy#(i) = 1


If i < 200 Then
r = 100: g = 100: b = 100
sx#(i) = xbewegen(sx#(i), sternwinkel#, 1)
sy#(i) = ybewegen(sy#(i), sternwinkel#, 1)
EndIf

If i < 350 And i > 199 Then
r = 170: g = 170: b = 170
sx#(i) = xbewegen(sx#(i), sternwinkel#, 2)
sy#(i) = ybewegen(sy#(i), sternwinkel#, 2)
EndIf

If i > 349 Then
r = 255: g = 255: b = 255
sx#(i) = xbewegen(sx#(i), sternwinkel#, 3)
sy#(i) = ybewegen(sy#(i), sternwinkel#, 3)
EndIf


; WritePixelFast ist deswegen schneller als Plot und WritePixel weil es
; nicht prft ob der Punkt noch auf dem Bildschirm liegt (und noch durch andere Methoden).
; Dadurch kommt es aber auch zu abstrzen wenn man den Punkt zufllig auerhalb
; des Bildschirms zeichnet. Also --> Vorsicht...
WritePixelFast sx#(i), sy#(i), rgb(r,g,b)
Next
UnlockBuffer BackBuffer() ; Und wieder entsperren



End Function













Function ende()

; Nochmal die ganzen Kreise malen.
zeit = MilliSecs()
Repeat
Cls
For x = 0 To 32
For y = 0 To 24
Color 153,(y*20) / 2, (x*15) / 2
Oval x*20, y*20, 20,20
Color (x*15) / 2,(y*20) / 2, 153
Oval x*20, y*20, 20,20,0
Next
Next
Text Rnd(300,301), Rnd(240,241), "ENDE"
Flip
Until MilliSecs() - zeit >= 4000  Or KeyHit(1) Or KeyHit(28); 4 Sekunden warten. (4000 Millisekunden)

Repeat
Cls
Color Rnd(0,255), Rnd(0,255), Rnd(0,255)
Text Rnd(240,242), Rnd(240,242), "Dein Score: " + score

; Ein paar bunte Punkte
For i = 1 To 1000
Color Rnd(0,255), Rnd(0,255), Rnd(0,255)
Plot Rnd(0,640), Rnd(0,480)
Next

Flip
Until KeyHit(1) Or KeyHit(28)
End
End Function






Function kollisionpruefen()
; Schlangenkopf auf Kollision mit Punkt berprfen
If x = px And y = py Then
laenge = laenge + 3 ; Schlange wird lnger
For i = laenge -3 To laenge
snakex(i) = snakex(i-1)
snakey(i) = snakey(i-1)
Next
score = score + laenge ; Man bekommt mehr Punkte je lnger die Schlange ist.

px = Rnd(1,28)
py = Rnd(1,22)

EndIf

End Function






Function status()

Color 255,255,255
Text 320 - (StringWidth(Str(score))/2) , 1, score

End Function






; Errechnet den Winkel zwischen zwei Koordinaten.
Function winkel#(x1#,y1#,x2#,y2#)
xhypo# = x2# - x1#
yhypo# = y2# - y1#

; Sqr = Wurzel
abstand# = Abs(Sqr((xhypo# ^ 2) + (yhypo# ^2)))

winkel# = Abs(ACos(xhypo#/abstand#))

If Sgn(xhypo#) = -1 And Sgn(yhypo#) = -1 Then winkel# = 180 + (180 - winkel#)
If Sgn(xhypo#) = 1 And Sgn(yhypo#) = -1 Then winkel# = 270 + (90 - winkel#)

Return winkel#
End Function




; Einene Punkt(Stern) in eine Richtung bewegen.
Function xbewegen#(x#,winkel#,speed#)
x2# = x# + Cosinus#(winkel#)*speed#
Return x2#
End Function

; Das gleiche mit y#.
Function ybewegen#(y#,winkel#,speed#)
y2# = y# + Sinus#(winkel#)*speed#
Return y2#
End Function



; Aus RGB-Werten einen ReadPixelFast-Farbwert errechnen. 
Function rgb(rot,gruen,blau)
Return blau Or (gruen * 256) Or (rot * 65536)
End Function